import { jsx as _jsx } from "react/jsx-runtime";
import { InputAdornment } from "@mui/material";
import NerdMaskField from "../nerdMaskField/nerdMaskField";
/**
 *
 * @param {NerdCurrencyFieldProps} props Component props
 * @returns {ReactElement} NerdCurrencyField
 */
export default function NerdCurrencyField(props) {
    const { value, onChange, textFieldProps, currencySymbol = "$", decimalCharacter = ".", digitGroupSeparator = ",", multiplier, signed, normalizeZeros = false, padFractionalZeros = false, max, min, maxDigitAfterDecimal, } = props;
    return (_jsx(NerdMaskField, { value: value != undefined
            ? multiplier
                ? value != "-"
                    ? (value / multiplier).toString()
                    : value
                : value.toString()
            : "", textFieldProps: {
            ...textFieldProps,
            InputProps: {
                startAdornment: (_jsx(InputAdornment, { position: "start", children: currencySymbol })),
                ...textFieldProps?.InputProps,
            },
            inputProps: {
                ...textFieldProps?.inputProps,
                sx: { textAlign: "right", ...textFieldProps?.inputProps?.sx },
            },
        }, mask: "m", blocks: {
            m: {
                mask: Number,
                signed,
                thousandsSeparator: digitGroupSeparator,
                scale: multiplier && multiplier > 9
                    ? multiplier.toFixed().length - 1
                    : maxDigitAfterDecimal != undefined
                        ? maxDigitAfterDecimal
                        : 16,
                normalizeZeros,
                radix: decimalCharacter,
                padFractionalZeros,
                max,
                min,
            },
        }, onAccept: (inputValue, mask) => {
            if (inputValue !== "-" &&
                !inputValue.match(new RegExp(`^-0*\\${decimalCharacter}?0*$`))) {
                const newValue = Number(mask.unmaskedValue);
                if (mask.value === "")
                    onChange?.(undefined);
                else if (newValue != value) {
                    onChange?.(multiplier ? newValue * multiplier : newValue);
                }
            }
        } }));
}
