import { ReactElement, ReactNode } from "react";
import { Duration } from "luxon";
import { FormControlProps, FormLabelProps, InputProps } from "@mui/joy";
export interface NerdTimeObject {
    value: string | null;
    duration: Duration | null;
    isValid: boolean;
}
export interface NerdTimePickerProps {
    format?: "12" | "24";
    startTime?: string;
    sameDay?: boolean;
    onChange: (time: NerdTimeObject) => void;
    value: string | null;
    showDiff?: boolean;
    formLabelProps?: FormLabelProps;
    formControlProps?: FormControlProps;
    inputProps?: InputProps;
    helperText?: ReactNode;
    label?: ReactNode;
    openOnFocus?: boolean;
}
/**
 *
 * @param {string} time Time
 * @param {string} format Format
 * @returns {Duration} Duration from string
 */
export declare function durationFromString(time: string, format: "12" | "24"): Duration;
/**
 *
 * @param {NerdTimePickerProps} props Props
 * @returns {ReactElement} NerdTimePicker
 */
export default function NerdTimePicker(props: NerdTimePickerProps): ReactElement;
